<!--
  -    Copyright [2020] Feather development team, see AUTHORS.md
  -
  -    Licensed under the Apache License, Version 2.0 (the "License");
  -    you may not use this file except in compliance with the License.
  -    You may obtain a copy of the License at
  -
  -        http://www.apache.org/licenses/LICENSE-2.0
  -
  -    Unless required by applicable law or agreed to in writing, software
  -    distributed under the License is distributed on an "AS IS" BASIS,
  -    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -    See the License for the specific language governing permissions and
  -    limitations under the License.
  -->

<template>
  <v-row>
    <v-col>
      <v-card>
        <v-card-title> Benutzer Löschen </v-card-title>
        <v-card-text>
          <v-alert type="success" v-if="success"> Benutzer wurde erfolgreich gelöscht. </v-alert>

          <v-form ref="form" v-if="!success">
            <v-alert type="warning" v-if="error">
              Bitte folgende Fehler beheben:
              <ul>
                <li v-for="e in error" :key="e">
                  {{ e }}
                </li>
              </ul>
            </v-alert>

            <v-text-field
              label="Anzeigename"
              prepend-icon="mdi-card-account-details"
              v-model="applicationStore.session.user.displayName"
              disabled
            />

            <v-text-field
              label="E-Mail"
              prepend-icon="mdi-email"
              v-model="applicationStore.session.user.mail"
              disabled
            />

            <v-checkbox
              v-model="deleteuser.verified"
              :rules="[(v) => !!v || 'Die Zustimmung ist erforderlich']"
              :disabled="sending"
              required
            >
              <template v-slot:label>
                Ja, ich will dass mein Account und alle meine persönlichen Daten gelöscht werden.
              </template>
            </v-checkbox>

            <v-text-field
              label="Passwort"
              name="password"
              type="password"
              prepend-icon="mdi-lock"
              v-model="deleteuser.password"
              :disabled="sending"
            />
          </v-form>
        </v-card-text>
        <v-card-actions>
          <v-spacer />
          <v-btn
            color="orange darken-2"
            class="pa-4 white--text"
            tile
            @click="doDeleteUser"
            :loading="sending"
            :disabled="sending"
            v-if="!success"
            >Endgültig Löschen
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-col>
    <v-col
      v-if="
        applicationStore.session.user.permissions.includes('ADMIN') &&
        !applicationStore.session.miniSession
      "
    >
      <v-card>
        <v-card-title class="red--text"> Mehrere Benutzer Löschen </v-card-title>
        <v-card-text>
          <v-alert type="success" v-if="success2">
            Benutzer wurde(n) erfolgreich gelöscht.
          </v-alert>

          <v-form ref="form2" v-if="!success2">
            <v-alert type="warning" v-if="error2">
              Bitte folgende Fehler beheben:
              <ul>
                <li v-for="e in error2" :key="e">
                  {{ e }}
                </li>
              </ul>
            </v-alert>

            <!-- item-disabled is set to something user, since a disabled user else triggers it -->
            <v-autocomplete
              v-model="deleteusers.users"
              :items="this.items"
              item-text="displayName_and_username"
              item-value="id"
              item-disabled="null"
              label="Zu löschende Benutzer"
              multiple
              chips
              prepend-icon="mdi-account-multiple"
              :disabled="loading || sending"
            ></v-autocomplete>

            <v-checkbox
              v-model="deleteusers.verified"
              :rules="[(v) => !!v || 'Die Zustimmung ist erforderlich']"
              :disabled="sending"
              required
            >
              <template v-slot:label>
                Ja, alle ausgewählten Accounts und alle persönlichen Daten dieser Accounts sollen
                gelöscht werden.
              </template>
            </v-checkbox>

            <v-text-field
              label="Passwort"
              name="password"
              type="password"
              prepend-icon="mdi-lock"
              v-model="deleteusers.password"
              :disabled="sending"
            />
          </v-form>
        </v-card-text>
        <v-card-actions>
          <v-btn
            color="orange darken-2"
            class="pa-4 white--text"
            tile
            @click="reset"
            v-if="success2"
            >Weitere Benutzer löschen
          </v-btn>
          <v-spacer />
          <v-btn
            color="orange darken-2"
            class="pa-4 white--text"
            tile
            @click="doDeleteUsers"
            :loading="sending"
            :disabled="sending"
            v-if="!success2"
            >Endgültig Löschen
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-col>
  </v-row>
</template>

<script>
import Api from '../../LegacyApi';
import * as util from "../../util";
import { useApplicationStore } from '../../stores/application';

export default {
  mounted() {
    this.initUsers();
  },
  data: () => {
    return {
      loading: true,
      sending: false,
      success: false,
      success2: false,
      error: null,
      error2: null,
      users: [],
      items: [],
      deleteuser: {
        verified: false,
        password: '',
      },
      deleteusers: {
        users: [],
        verified: false,
        password: '',
      },
      applicationStore: useApplicationStore(),
      util,
    };
  },
  methods: {
    initUsers: function () {
      if (!this.applicationStore.session.miniSession) {
        Api.defaultHandler(this, Api.getAllUsers()).then((result) => {
          this.users = result;
          this.items = Array.from(this.users.values()).map((user) =>
            Object.assign(user, {
              displayName_and_username: util.userUniqueIdentifier(user),
            })
          );
          this.loading = false;
        });
      }
    },
    reset: function () {
      this.error2 = null;
      this.deleteuser.verified = false;
      this.deleteuser.password = '';
      this.deleteusers.users = [];
      this.deleteusers.verified = false;
      this.deleteusers.password = '';
      this.sending = false;
      this.success2 = false;
    },
    doDeleteUser: function () {
      if (this.$refs.form.validate()) {
        this.$emit('clearError');
        this.sending = true;

        fetch(
          util.CONFIG.API_BASE_URL +
            '/v1/bindings/multiservice/users/' +
            this.applicationStore.session.user.id,
          {
            method: 'DELETE',
            credentials: 'include',
            body: JSON.stringify(this.deleteuser),
          }
        )
          .then((response) => {
            if (response.status === 200) {
              // this.success = true;
              // logout because user has been deleted
              this.$router.push('/logout');
            } else if (response.status === 401) {
              // unauthorized, ask to login  again
              this.$router.push('/logout');
            } else if (response.status === 403) {
              // forbidden, no permissions or wrong password
              this.sending = false;
              this.error = ['Falsches Passwort'];
            } else if (response.status === 400) {
              this.sending = false;
              response
                .json()
                .then((data) => {
                  this.error = data;
                })
                .catch((error) => {
                  console.log(error);
                  this.$emit('unexpectedError');
                });
            } else {
              this.sending = false;
              this.$emit('unexpectedError');
            }
          })
          .catch((error) => {
            console.log(error);
            this.sending = false;
            this.$emit('networkError');
          });
      }
    },
    doDeleteUsers: function () {
      if (this.$refs.form2.validate()) {
        this.$emit('clearError');
        this.sending = true;

        fetch(util.CONFIG.API_BASE_URL + '/v1/bindings/multiservice/users/delete', {
          method: 'POST',
          credentials: 'include',
          body: JSON.stringify(this.deleteusers),
        })
          .then((response) => {
            if (response.status === 201) {
              this.success2 = true;
              // reload list of users
              this.initUsers();
            } else if (response.status === 401) {
              // unauthorized, ask to login  again
              this.$router.push('/logout');
            } else if (response.status === 403) {
              // forbidden, no permissions or wrong password
              this.sending = false;
              this.error2 = ['Keine Berechtigung oder falsches Passwort'];
            } else if (response.status === 400) {
              this.sending = false;
              response
                .json()
                .then((data) => {
                  this.error2 = data;
                })
                .catch((error) => {
                  console.log(error);
                  this.$emit('unexpectedError');
                });
            } else {
              this.sending = false;
              this.$emit('unexpectedError');
            }
          })
          .catch((error) => {
            console.log(error);
            this.sending = false;
            this.$emit('networkError');
          });
      }
    },
  },
  beforeUnmount() {
    this.$emit('clearError');
  },
};
</script>

<style scoped></style>
